# -*- coding: utf-8
import pilasengine
from emisorHUMO import * 

pilas = pilasengine.iniciar(ancho=900, alto=550, titulo='De la tierra a la luna')

puntaje = pilas.actores.Puntaje(280, 200, color=pilas.colores.blanco)
fondo = pilas.fondos.Galaxia(dx=-2, dy=0)


class Nave(pilasengine.actores.Actor):

    def iniciar(self):
        self.imagen = "imagenes/lanave.png"

	    
minave = Nave(pilas);
minave.z = -2

c2 = pilas.fisica.Circulo(minave.x, minave.y, 100, restitucion=0.1, amortiguacion=0.5)
minave.imitar(c2)

emisor = EmisorHUMO(pilas, 0, 0)
emisor.imagen_particula = pilas.imagenes.cargar_grilla("imagenes/humo.png")
emisor.constante = True
emisor.composicion = "blanco"
emisor.duracion = 2
emisor.frecuencia_creacion = 0.03
emisor.vida = 8
emisor.aceleracion_x_min = 36
emisor.aceleracion_x_max = 50
emisor.x_min = 171
emisor.y_min = 2
emisor.transparencia_min = 30
emisor.transparencia_max = 50

emisor.aprender(pilas.habilidades.Imitar, minave)

minave.aprender(pilas.habilidades.MoverseConElTeclado)
minave.aprender(pilas.habilidades.LimitadoABordesDePantalla)



class Asteroide(pilasengine.actores.Actor):

    def iniciar(self):
        self.imagen = "imagenes/asteroide.png"
        self.escala = 0.3
        self.x = -500
        self.y = pilas.azar(-300, 300)
        self.giro = 2
        self.z = self.y
        
    def actualizar(self):
        self.rotacion += self.giro
        self.x += 2
        # Elimina el objeto cuando sale de la pantalla.
        if self.x > 500:
            self.eliminar()

#defino un grupo de enemigos
enemigos = pilas.actores.Grupo()

def crear_asteroide():
	#creo el actor enemigo
    asteroide = Asteroide(pilas);
    #creo un objeto para la física
    c1 = pilas.fisica.Circulo(asteroide.x, asteroide.y, 100, restitucion=1, amortiguacion=2)
    asteroide.imitar(c1)
    #lo agrego al grupo
    enemigos.agregar(asteroide)


# Creo una tarea para que aparezca un asteroide cada 2 segundos.
pilas.tareas.siempre(2, crear_asteroide)  

def nave_choco():#Cuando un asteroide choca nave
    #minave.y = [minave.y +5, minave.y -5],0.2
    pilas.camara.vibrar(3, 0.5)
    
		
# Creo un control de coliciones para saber cuando perdes
pilas.colisiones.agregar(minave, enemigos, nave_choco)

#Elimino los límites laterales y la gravedad
pilas.fisica.gravedad_x = 0
pilas.fisica.gravedad_y = 0
pilas.fisica.eliminar_paredes()
pilas.fisica.eliminar_techo()
pilas.fisica.eliminar_suelo()



pilas.ejecutar()
